//-----------------------------------------------------------
// smpl12(tc_intervaltimer).c
// ^C}JE^ɂC^[o^C}
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// TĈ2chC^[o^C}Ƃč\AԊu
// 荞݂𔭐B
// eX̃^C}荞݂ŕʁX̏ȂB
//-----------------------------------------------------------

#include <stdio.h>

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _LED1 ((uint32_t)1 << 19) // PB19 -> LED1
#define _LED2 ((uint32_t)1 << 20) // PB20 -> LED2
#define _LED3 ((uint32_t)1 << 21) // PB21 -> LED3
#define _LED4 ((uint32_t)1 << 22) // PB22 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#else
#define _LED1 ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2 ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3 ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4 ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#endif
static const TPin pins[] = {
  {_ALL_LED, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
};

uint32_t cnt = 0;

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

static __inline__ void PIOA_SetOutput (uint32_t v) {
  PIOA.SODR = v;
}

static __inline__ void PIOA_ClearOutput (uint32_t v) {
  PIOA.CODR = v;
}

//========================================================
// PIO
//========================================================
void led (uint8_t d) {
  if (d & 1) PIOA_ClearOutput (_LED1); else PIOA_SetOutput (_LED1);
  if (d & 2) PIOA_ClearOutput (_LED2); else PIOA_SetOutput (_LED2);
  if (d & 4) PIOA_ClearOutput (_LED3); else PIOA_SetOutput (_LED3);
  if (d & 8) PIOA_ClearOutput (_LED4); else PIOA_SetOutput (_LED4);
}

//========================================================
// Timer/Counter
//========================================================
//--------------------------------------------------------
// TC0
//--------------------------------------------------------
void TC0_irq_handler (void) {
  static uint32_t pattern = 0;

  // clear status
  TC.CHANNEL[0].SR;

  led (pattern++);
}

void TC0_Init (void) {
  // Set up timer
  PMC.PCER = 1 << TC0_PID; // Enable T0 peripheral clock
  TC.CHANNEL[0].CCR = _TC_CLKEN;
  TC.CHANNEL[0].IDR = -1;
  TC.CHANNEL[0].CMR = _TC_CLKS_MCK_128;     // /128
  TC.CHANNEL[0].CMR |= _TC_WAVESEL_UP_AUTO;
  TC.CHANNEL[0].RC = 37500 - 1;             // /128/37500=10[Hz]=0.1[s]
  TC.CHANNEL[0].IER = _TC_CPCS;
  TC.CHANNEL[0].CCR = _TC_CLKEN | _TC_SWTRG;

  // Set up timer interrupt
  AIC.IDCR = 1 << TC0_PID;
  AIC.SVR[TC0_PID] = (void *)TC0_irq_handler;
  AIC.SMR[TC0_PID] = _AIC_SRCTYPE_INT_HIGH_LEVEL | _AIC_PRIOR_LOWEST;
  AIC.ICCR = 1 << TC0_PID;
  AIC.IECR = 1 << TC0_PID;
}

//--------------------------------------------------------
// TC1
//--------------------------------------------------------
void TC1_irq_handler (void) {
  // clear status
  TC.CHANNEL[1].SR;

  cnt++;
}

void TC1_Init (void) {
  // Set up timer
  PMC.PCER = 1 << TC1_PID; // Enable T1 peripheral clock
  TC.CHANNEL[1].CCR = _TC_CLKEN;
  TC.CHANNEL[1].IDR = -1;

  TC.CHANNEL[1].CMR = _TC_CLKS_MCK_8;       // /8
  TC.CHANNEL[1].CMR |= _TC_WAVESEL_UP_AUTO;
  TC.CHANNEL[1].RC = 6000 - 1;              // /8/6000=1[kHz]=1[ms]
  TC.CHANNEL[1].IER = _TC_CPCS;
  TC.CHANNEL[1].CCR = _TC_CLKEN | _TC_SWTRG;

  // Set up timer interrupt
  AIC.IDCR = 1 << TC1_PID;
  AIC.SVR[TC1_PID] = (void *)TC1_irq_handler;
  AIC.SMR[TC1_PID] = _AIC_SRCTYPE_INT_HIGH_LEVEL | _AIC_PRIOR_LOWEST;;
  AIC.ICCR = 1 << TC1_PID;
  AIC.IECR = 1 << TC1_PID;
}

//========================================================
// main
//========================================================
void main (void) {
  enableIRQ ();
  PIO_Configure (pins, PIO_LISTSIZE (pins));
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  TC0_Init ();
  TC1_Init ();

  _us_printf ("START!\n\r");

  for (;;)  {
    if (_us_rx_buff ()) {
      switch (_us_getc ()) {
#if 1
        case 0x1b:
#if defined (__UDP__)
          udp_disconnect ();
          wait(5000); // EFCgȂƃzXgUSB̃ZbgołȂ
#endif
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
          break;
#endif
        case 's':
          _us_printf ("\rEN TC0            \n");
          AIC.IECR = 1 << TC0_PID;
          break;
        case 'e':
          _us_printf ("\rDI TC0            \n");
          AIC.IDCR = 1 << TC0_PID;
          break;

        case 'S':
          _us_printf ("\rEN TC1            \n");
          AIC.IECR = 1 << TC1_PID;
          break;
        case 'E':
          _us_printf ("\rDI TC1            \n");
          AIC.IDCR = 1 << TC1_PID;
          break;
      }
    }
    _us_printf ("\rcnt=%7d        ", cnt);
    wait (100);
  }
}
