//-----------------------------------------------------------
// smpl4(us0_dx).c
// US0ɂ锼dVAʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// US0DynamixelƃVAʐMsB
// AX-12+̃ftHgz肵Ă邽߃{[[g1MbpsA
// ID1z肵ĂB
//-----------------------------------------------------------

#include <stdlib.h>

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <string.h>
#include <vic.h>
#include <piocfg.h>
#include <us.h>

#define __UDP__   // US0͎w肵Ȃ
#include "share/us.c"

// US0pMobt@
static char us0tbuf[500], us0rbuf[500];
// DXvgR̃CXgNV
typedef enum {INST_PING=1, INST_READ=2, INST_WRITE=3, INST_REG_WRITE=4, INST_ACTION=5, INST_RESET=6, INST_SYNC_WRITE=0x83, INST_SYNG_REG_WRITE=0x85} TInstruction;

// G[yуXe[^XtO
#define ERR_INVALID_ID      (1 << 14)
#define ERR_DIFF_ID         (1 << 13)
#define ERR_ILLEGAL_SIZE    (1 << 12)
#define ERR_INVALID_PARAM   (1 << 11)
#define ERR_COMM            (1 << 10)
#define ERR_CHECKSUM        (1 << 9)
#define ERR_TIMEOUT         (1 << 8)
#define ERR_DX_INST         (1 << 6)
#define ERR_DX_OVERLOAD     (1 << 5)
#define ERR_DX_CHECKSUM     (1 << 4)
#define ERR_DX_RANGE        (1 << 3)
#define ERR_DX_OVERHEAT     (1 << 2)
#define ERR_DX_ANGLE        (1 << 1)
#define ERR_DX_OVERVOLTAGE  (1 << 0)
#define ERR_NON             (0)

// etc
#define BROADCASTING_ID           0xfe

#define ADDRESS_GOAL_POSITION     30
#define ADDRESS_TORQUE_LIMIT      34
#define ADDRESS_PRESENT_POSITION  36
#define ADDRESS_LED               25

#define _TIMEOUT                  100

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// UART0
//========================================================
void Init_US0 (int baud) {
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
  TPin rtspin[] = {
    {1 << 8, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},  // PA8 -> RTS0
  };
#else
  TPin rtspin[] = {
    {1 << 7, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},  // PA7 -> RTS0
  };
#endif
  // pdcɂUS0𐧌  TXD0RXD0[q
  us0_pdc_init (baud, us0tbuf, sizeof(us0tbuf), us0rbuf, sizeof(us0rbuf));
  // Dynamixel͔dʐMƂȂ邽߁AUS0RS485[hRTS0[qǉŊ
  USART0.MR = (_US_CLKS_CLOCK | _US_CHRL_8_BITS | _US_PAR_NONE | _US_NBSTOP_1_BIT | _US_USMODE_RS485 | _US_OVER);
  PIO_Configure (rtspin, PIO_LISTSIZE (rtspin));
}

// DXpPbgM
uint8_t DX_TxPacket (uint8_t *txdata, uint8_t id, TInstruction inst, const uint8_t *param, int len, uint16_t *errcode) {
  uint8_t i, SUM;
  char tbuf[150];

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return 0;
  }

  if ((id > 0xfe) || (len > 120)) {
    *errcode = ERR_INVALID_PARAM;
    return 0;
  }

  while (us0_pdc_tx_buff ()) ;

  *errcode = ERR_NON;

  tbuf[0] = tbuf[1] = 0xff;
  SUM = (tbuf[2] = id);
  SUM += (tbuf[3] = (uint8_t)(len + 2));
  SUM += (tbuf[4] = (uint8_t)inst);
  for (i = 0; i < len; i++) SUM += (tbuf[i + 5] = param[i]);
  tbuf[len + 5] = ~SUM;
  if (txdata != NULL) memcpy (txdata, tbuf, len);
  us0_pdc_sys_puts (tbuf, len + 6);

  return len + 4 + 2;
}

#define _PAUSE1MS  33

// DXpPbgM
int DX_RxPacket (uint8_t *rxdata, int sz, int *len, uint32_t timeout, uint16_t *errcode) {
  uint8_t c;
  uint8_t CCheckSum = 0;
  int result = 0;
  char mydxrxbuf [150];
  char PacketStatus = 0;
  int     PacketIndex1 = 0, PacketIndex2 = 0;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return 0;
  }

  RTT.MR = _RTT_RTTRST;
  while (RTT.SR & _RTT_ALMS);
  RTT.AR = timeout;
  RTT.MR = _RTT_RTTRST | _PAUSE1MS; // Configure the RTT:

  *errcode = ERR_NON;

  while (1) {
    if ((RTT.SR & _RTT_ALMS) == 0) {
      while (us0_pdc_rx_buff ()) {
        c = us0_pdc_getc ();
        switch (PacketStatus) {
          // 1byte [$FF]
          case 0:
            if (c == 0xff) {
              PacketStatus = 1;
              mydxrxbuf[0] = c;
            }
            break;
          // 2byte [$FF]
          case 1:
            if (c == 0xff) {
              CCheckSum = 0;
              PacketIndex1 = 0;
              PacketStatus = 2;
              mydxrxbuf[1] = c;
            } else
              PacketStatus = 0;
            break;
          // 3byte [ID] [LEN] [ERR] [PARAM1]....[PARAMn]
          case 2:
            mydxrxbuf[(2 + PacketIndex1)] = c;
            CCheckSum += c;
            switch (PacketIndex1) {
              case 0:   // [ID]
                break;
              case 1:   // [LEN]
                PacketIndex2 = c - 1;
                if (PacketIndex2 + 3 >= 120) PacketStatus = 0;
                break;
              default:
                if (PacketIndex1 >= 200) PacketStatus = 0;
                else {
                  PacketIndex2--;
                  if (PacketIndex2 == 0) {
                    CCheckSum = (~(CCheckSum)) & 0xff;
                    PacketStatus = 3;
                  }
                }
                break;
            }
            PacketIndex1++;
            break;
          // final byte [SUM]
          case 3:
            mydxrxbuf[(2 + PacketIndex1)] = c;
            if (CCheckSum == c) {
              result = mydxrxbuf[3] + 4;
              if (sz > result) {
                *len = result;
                if (rxdata != NULL) memcpy (rxdata, mydxrxbuf, (int)result);
                *errcode = mydxrxbuf[4];
              } else {
                *errcode = ERR_ILLEGAL_SIZE;
                break;
              }
            } else
              *errcode = ERR_CHECKSUM;
            PacketStatus = 0;
            return result;
            break;
          default:
            PacketStatus = 0;
            break;
        }
      }
    } else {
      *errcode = ERR_TIMEOUT;
      break;
    }
  }

  return result;
}

// oCgf[^擾
bool DX_ReadByteData (uint8_t id, uint8_t adr, uint8_t *result, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5];
  uint8_t   rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }
  if (id == BROADCASTING_ID) {
    *errcode = ERR_INVALID_ID;
    return b;
  }

  param[0] = adr;
  param[1] = 1;
  if (DX_TxPacket (NULL, id, INST_READ, param, 2, &err) > 0) {
    if (DX_RxPacket (rbuf, sizeof(rbuf), &l, timeout, &err) > 0) {
      if (rbuf[2] == id) {
        if (l == 7) {
          if ((err & 0x78) == 0) {
            *result = rbuf[5];
            b = true;
          } else
            *errcode = err;
        } else
          *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
      } else
        *errcode = ERR_DIFF_ID | (err & 0xff);
    } else
      *errcode = err;
  } else
    *errcode = err;

  return b;
}

// [hf[^擾
bool DX_ReadWordData (uint8_t id, uint8_t adr, uint16_t *result, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5];
  uint8_t   rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }
  if (id == BROADCASTING_ID) {
    *errcode = ERR_INVALID_ID;
    return b;
  }

  param[0] = adr;
  param[1] = 2;
  if (DX_TxPacket (NULL, id, INST_READ, param, 2, &err) > 0) {
    if (DX_RxPacket (rbuf, sizeof(rbuf), &l, timeout, &err) > 0) {
      if (rbuf[2] == id) {
        if (l == 8) {
          if ((err & 0x78) == 0) {
            *result = rbuf[5] + (rbuf[6] << 8);
            b = true;
          } else
            *errcode = err;
        } else
          *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
      } else
        *errcode = ERR_DIFF_ID | (err & 0xff);
    } else
      *errcode = err;
  } else
    *errcode = err;
  return b;
}

// ubNf[^擾
bool DX_ReadBlockData (uint8_t id, uint8_t adr, uint8_t *result, uint8_t len, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5];
  uint8_t   rbuf[200];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }
  if (id == BROADCASTING_ID) {
    *errcode = ERR_INVALID_ID;
    return b;
  }
  if (len > 120) {
    *errcode = ERR_ILLEGAL_SIZE;
    return b;
  }

  param[0] = adr;
  param[1] = len;
  if (DX_TxPacket (NULL, id, INST_READ, param, 2, &err) > 0) {
    if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err)) {
      if (rbuf[2] == id) {
        if (l == 6 + len) {
          if ((rbuf[4] & 0x78) == 0) {
            memcpy (result, rbuf + 5, len);
            b = true;
          } else
            *errcode = err;
        } else
          *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
      } else
        *errcode = ERR_DIFF_ID | (*errcode & 0xff);
    } else
      *errcode = err;
  } else
    *errcode = err;
  return b;
}

// oCgf[^
bool DX_WriteByteData (uint8_t id, uint8_t adr, uint8_t dat, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5];
  uint8_t   rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }

  param[0] = adr;
  param[1] = dat;
  if (DX_TxPacket (NULL, id, INST_WRITE, param, 2, &err) > 0) {
    if (id != BROADCASTING_ID) {
      if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err) > 0) {
        if (rbuf[2] == id) {
          if (l == 6) {
            if ((err & 0x78) == 0) {
              b = true;
            } else
              *errcode = err;
          } else
            *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
        } else
          *errcode = ERR_DIFF_ID | (err & 0xff);
      } else
        *errcode = err;
    } else {
      while (us0_pdc_tx_buff ()) ;
      b = true;
    }
  } else
    *errcode = err;
  return b;
}

// [hf[^
bool DX_WriteWordData (uint8_t id, uint8_t adr, uint16_t dat, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5];
  uint8_t   rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }

  param[0] = adr;
  param[1] = dat & 0xff;
  param[2] = dat >> 8;
  if (DX_TxPacket (NULL, id, INST_WRITE, param, 3, &err) > 0) {
    if (id != BROADCASTING_ID) {
      if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err) > 0) {
        if (rbuf[2] == id) {
          if (l == 6) {
            if ((err & 0x78) == 0) {
              b = true;
            } else
              *errcode = err;
          } else
            *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
        } else
          *errcode = ERR_DIFF_ID | (err & 0xff);
      } else
        *errcode = err;
    } else {
      while (us0_pdc_tx_buff ()) ;
      b = true;
    }
  } else
    *errcode = err;
  return b;
}

// ubNf[^
bool DX_WriteBlockData (uint8_t id, uint8_t adr, const uint8_t *dat, uint8_t len, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[200];
  uint8_t   rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }
  if (len > 120) {
    *errcode = ERR_ILLEGAL_SIZE;
    return b;
  }

  param[0] = adr;
  memcpy (&param[1], dat, len);
  if (DX_TxPacket (NULL, id, INST_WRITE, param, len + 1, &err) > 0) {
    if (id != BROADCASTING_ID) {
      if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err) > 0) {
        if (rbuf[2] == id) {
          if (l == 6) {
            if ((rbuf[4] & 0x78) == 0) {
              b = true;
            } else
              *errcode = err;
          } else
            *errcode = ERR_ILLEGAL_SIZE | (err & 0xff);
        } else
          *errcode = ERR_DIFF_ID | (err & 0xff);
      } else
        *errcode = err;
    } else {
      while (us0_pdc_tx_buff ()) ;
      b = true;
    }
  } else
    *errcode = err;
  return b;
}

// 
bool DX_SyncWriteData (uint8_t size, const uint8_t *dat, uint16_t *errcode) {
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (!(USART0.IMR & _US_ENDRX)) {
    *errcode = ERR_COMM;
    return b;
  }
  if (size > 120) {
    *errcode = ERR_ILLEGAL_SIZE;
    return b;
  }

  b = (DX_TxPacket (NULL, BROADCASTING_ID, INST_SYNC_WRITE, dat, size, &err) > 0);
  while (us0_pdc_tx_buff ()) ;
  *errcode = err;
  return b;
}

// PING
bool DX_Ping (uint8_t id, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5], rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (id == BROADCASTING_ID) {
    *errcode = ERR_INVALID_ID;
    return b;
  }

  if (DX_TxPacket (NULL, id, INST_PING, param, 0, &err) > 0) {
    if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err) > 0) {
      b = ((rbuf[2] == id) && (l == 6));
    }
  }
  *errcode = err;
  return b;
}

// PING2
bool DX_Ping2 (uint8_t *id, uint32_t timeout, uint16_t *errcode) {
  int       l;
  uint8_t   param[5], rbuf[10];
  bool      b = false;
  uint16_t  err;

  *errcode = ERR_NON;

  if (DX_TxPacket (NULL, BROADCASTING_ID, INST_PING, param, 0, &err) > 0) {
    if (DX_RxPacket (rbuf, sizeof (rbuf), &l, timeout, &err) > 0) {
      b = ((rbuf[2] < BROADCASTING_ID) && (l == 6));
      if (b) *id = rbuf[2];
    }
  }
  *errcode = err;
  return b;
}

//========================================================
// main
//========================================================
void main (void) {

  enableIRQ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // US0DynamixelpI/FƂď
  Init_US0 (1000000);

  wait (5000);

  uint16_t gpos = 0, ppos = 0;
  uint8_t led = 0;
  uint16_t err;
  int dir = -1;

  // ݈ʒuǂݏo
  if (DX_ReadWordData(1, ADDRESS_PRESENT_POSITION, &ppos, _TIMEOUT, &err)) {
    _us_printf("\nini pos = %d\n", ppos);
    gpos = ppos;
  } else
    _us_printf("read word error [$%04X]\n", err);

  // gN~bgႭݒ
  if (!DX_WriteWordData (1, ADDRESS_TORQUE_LIMIT, 256, _TIMEOUT, &err))
    _us_printf("write byte error [$%04X]\n", err);

  while (1) {
    // ʒuw
    if (!DX_WriteWordData (1, ADDRESS_GOAL_POSITION, gpos, _TIMEOUT, &err))
      _us_printf("write word error [$%04X]\n", err);
    // ݈ʒuǂݏo
    if (DX_ReadWordData (1, ADDRESS_PRESENT_POSITION, &ppos, _TIMEOUT, &err))
      _us_printf("\rpos = %d\33[K", ppos);
    else
      _us_printf("read word error [$%04X]\n", err);
    // LEDw
    if (!DX_WriteByteData (1, ADDRESS_LED, led, _TIMEOUT, &err))
      _us_printf("write byte erro [$%04X]\n", err);

    led ^= 1;

    gpos = gpos + dir;
    if (gpos >= 1023) { gpos = 1023; dir = -1; }
    else if (gpos <= 0) { gpos = 0; dir = 1; }
  }
}
