//-----------------------------------------------------------
// smpl5(us1_zeal).c
// UDP(USB)yUS1(ZEAL)ɂVAʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// US1ɐڑꂽZEAL-C01(BluetoothW[)ƒʐMB
//
// ZEAL-C01̓n[ht[v邽߁AƂ肠PDCgp
// US1pCugpB
// US1ɂ莩IɃt[s킹ꍇ FLOWCTRL }N
// 錾A錾Ȃꍇ̓t[sȂB
//-----------------------------------------------------------
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>

#include <vic.h>
#include <piocfg.h>
#include <us.h>
#include <vic.h>

#define __UDP__   // US1͎w肵Ȃ
#include "share/us.c"

// US1̃t[gꍇɐ錾
// t[sȂꍇ͐[q펞ʐMɋ
#define FLOWCTRL

// PIO[qݒ
#define _ZEAL_RESET   ((uint32_t)1 << 8)  // PA8  -> ZEAL RESET
#define _ZEAL_RTS     ((uint32_t)1 << 24) // PA24 -> RTS0
#define _ZEAL_CTS     ((uint32_t)1 << 25) // PA25 -> CTS0
#define _ZEAL_MODE0   ((uint32_t)1 << 27) // PA27 -> ZEAL MODE0
#define _ZEAL_MODE1   ((uint32_t)1 << 28) // PA28 -> ZEAL MODE1

#define _LED1         ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2         ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3         ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4         ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED      (_LED1 | _LED2 | _LED3 | _LED4)
#define _PB1          ((uint32_t)1 << 17) // PA17 -> PB1
#define _PB2          ((uint32_t)1 << 18) // PA18 -> PB2
#define _PB3          ((uint32_t)1 << 19) // PA19 -> PB3
#define _PB4          ((uint32_t)1 << 20) // PA20 -> PB4
#define _ALL_PB       (_PB1 | _PB2 | _PB3 | _PB4)

static const TPin pins[] = {
  {_ZEAL_RESET, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
#if defined (FLOWCTRL)
  {_ZEAL_RTS,   &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  {_ZEAL_CTS,   &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_PULLUP },
#else
  {_ZEAL_RTS,   &PIOA, PIOA_PID, PIO_OUTPUT_0, PIO_DEFAULT},
  {_ZEAL_CTS,   &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
#endif
  {_ZEAL_MODE0, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ZEAL_MODE1, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},

  {_ALL_LED,    &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ALL_PB,     &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};

// ZEAL-C01̒ʏ탂[hȊOł(BTBR}hŐݒ肵){[[g
#define ZEAL_AUTO_BAUD  115200

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// PIO
//========================================================
// w[qHIGH
static __inline__ void PIOA_SetOutput (uint32_t d) {
  PIOA.SODR = d;
}

// w[qLOW
static __inline__ void PIOA_ClearOutput (uint32_t d) {
  PIOA.CODR = d;
}

// ꂽ{^ɉĐlԂ
int button (int *d) {
  uint32_t pdsr = (~PIOA.PDSR) & _ALL_PB;
  if (pdsr & _PB1) *d = 0;
  else if (pdsr & _PB2) *d = 1;
  else if (pdsr & _PB3) *d = 2;
  else if (pdsr & _PB4) *d = 3;
  else *d = -1;

  return pdsr != 0;
}

// 荞݂Ŋe[q̕ω𑨂LEDŏԂj^
void PIOA_irq_handler (void) {
  uint32_t isr = PIOA.ISR;
  uint32_t pdsr = PIOA.PDSR;

  if (isr & _ZEAL_MODE0) {
    if (pdsr & _ZEAL_MODE0) PIOA_ClearOutput (_LED1);
    else                    PIOA_SetOutput   (_LED1);
  }
  if (isr & _ZEAL_MODE1) {
    if (pdsr & _ZEAL_MODE1) PIOA_ClearOutput (_LED2);
    else                    PIOA_SetOutput   (_LED2);
  }

  if (isr & _ZEAL_CTS) {
    if (pdsr & _ZEAL_CTS)   PIOA_SetOutput   (_LED3);
    else                    PIOA_ClearOutput (_LED3);
  }
  if (isr & _ZEAL_RTS) {
    if (pdsr & _ZEAL_RTS)   PIOA_SetOutput   (_LED4);
    else                    PIOA_ClearOutput (_LED4);
  }
}

// ZEAL-C01̃[hύX
void changemode (int i) {
  if ((i < 0) || (i > 3)) return;

  PIOA_ClearOutput (_ZEAL_RESET | _ZEAL_MODE1 | _ZEAL_MODE0);
  switch (i) {
    case 0: // MODE0:0, MODE1:0 ݃[h
      us1_pdc_baudrate (9600);
      break;
    case 1: // MODE0:1, MODE1:0 [h
      PIOA_SetOutput (_ZEAL_MODE0);
      us1_pdc_baudrate (ZEAL_AUTO_BAUD);
      break;
    case 2: // MODE0:0, MODE1:1 ݒlN[h
      PIOA_SetOutput (_ZEAL_MODE1);
      us1_pdc_baudrate (ZEAL_AUTO_BAUD);
      break;
    case 3: // MODE0:1, MODE1:1 ʏ탂[h
      PIOA_SetOutput (_ZEAL_MODE1 | _ZEAL_MODE0);
      us1_pdc_baudrate (9600);
      break;
  }
  wait(10);
  PIOA_SetOutput (_ZEAL_RESET);
  _us_printf ("\nZEAL Mode=%3d\n", i);
}

void PIOA_Init (void) {
  PIOA.IER = _ZEAL_RTS | _ZEAL_CTS | _ZEAL_MODE0 | _ZEAL_MODE1;

  AIC.IDCR = 1 << PIOA_PID;
  AIC.SVR[PIOA_PID] = PIOA_irq_handler;
  AIC.SMR[PIOA_PID] = _AIC_SRCTYPE_INT_HIGH_LEVEL | _AIC_SRCTYPE_EXT_LOW_LEVEL | _AIC_PRIOR_LOWEST;
  AIC.ICCR = 1 << PIOA_PID;
  AIC.IECR = 1 << PIOA_PID;
}

//========================================================
// main
//========================================================
void main (void) {
  int i, l, m = 3;
  char s[1000];
  static char rxbu[10000], txbu[10000], txb1[10000], rxb1[10000];

  // 荞݋
  enableIRQ ();

  // PIO
  PIO_Configure (pins, PIO_LISTSIZE (pins));
  PIOA_Init ();

  // ʐM|[g
  _us_init (_BAUDRATE, txbu, sizeof (txbu), rxbu, sizeof (rxbu));

  // PDCgUS1 (ZEAL I/F)
  // ǉŃn[ht[(PDCł̂ݗL)
  us1_pdc_init (9600, txb1, sizeof (txb1), rxb1, sizeof (rxb1));
#if defined (FLOWCTRL)
  USART1.CR = _US_RSTRX | _US_RSTTX | _US_RXDIS | _US_TXDIS;
  USART1.MR = (USART1.MR & ~_US_USMODE) | _US_USMODE_HWHSH;
  USART1.CR = _US_TXEN | _US_RXEN;
#endif

  wait (5000);

  // Ԃ̃[hw
  changemode (m);

  while (1) {
    // R\[̓͂Ď
    if ((l = _us_rx_buff ())) {
      for (i = 0; (i < l) && (i < sizeof (s) - 1); i++) {
        if ((s[i] = _us_getc ()) == 0x1b) {
          wait (2000);
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
        }
      }
      l = i;
      _us_putb (s, l);          // R\[Ƀ[JGR[
      us1_pdc_sys_puts (s, l);  // R\[̓͂ZEAL-C01ɑM
    }

    // ZEAL̓͂Ď
    if ((l = us1_pdc_rx_buff ())) {
      for (i = 0; (i < l) && (i < sizeof (s) - 1); i++) s[i] = us1_pdc_getc ();
      l = i;
      _us_putb (s, l);          // ZEAL-C01̓͂R\[ɑM
    };

    // {^̏ԂĎ
    if (button (&m)) {
      // ZEAL-C01̓샂[hύX
      changemode (m);

      wait(10);
      while (button (&m));
      wait(10);
    }
  }
}
