//-----------------------------------------------------------
// smpl7(flash).c
// EFC
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// FLASH̎ȏsi񋟁B
//
// gŎ̃sAs
// R[h̎ԂRAMɒuĂB
// foCXɂFLASH̍\قȂ邽߁A{TvR
// pCۂ͐foCXIKvB
// RȂFLASH̎g̃R[hł̂ŁA^
// Ƀ}bvƃAhX̌vZȂƎEAvɂȂ肩
// ˂ȂB
//-----------------------------------------------------------

// RAM^[QbgƂăRpCƃsɂȂ̂ł
#if defined (_SRAM_TARGET__) | defined (__AT91SAM7S32__)
#error  MEMORY SHORTAGE
#endif

#include <stdlib.h>
#include  <string.h>

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

//========================================================
// EFC
//========================================================
#define _MC_CORRECT_KEY   ((uint32_t)0x5A << 24)  // (MC) Correct Protect Key
#define fmcn              (F_CPU / 1000000 + 30)
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
#define FLASH_FINAL_ADDR  (FLASH_BASE_ADDRESS + (FLASH_PAGE_SIZE_BYTE * FLASH_PAGE_NB) * 2)
#else
#define FLASH_FINAL_ADDR  (FLASH_BASE_ADDRESS + (FLASH_PAGE_SIZE_BYTE * FLASH_PAGE_NB))
#endif

// 
void FlashInit (void) {
  MC.EFC0.FMR = (_MC_FMCN & (fmcn << 16)) | _MC_FWS_1FWS;
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  MC.EFC1.FMR = (_MC_FMCN & (fmcn << 16)) | _MC_FWS_1FWS;
#endif
}

// READY҂
__attribute__((section(".ramfunc"))) int FlashReady (void) {
  uint32_t  status = 0;
  // Wait the end of command
  do {
    status = MC.EFC0.FSR;
  } while ((status & _MC_FRDY) == 0);
  return status;
}

#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
__attribute__((section(".ramfunc"))) int FlashReady2 (void) {
  uint32_t  status = 0;
  do {
    status = MC.EFC1.FSR;
  } while ((status & _MC_FRDY) == 0);
  return status;
}
#endif

__attribute__((section(".ramfunc"))) bool PageLocked (int page) {
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page < FLASH_PAGE_NB)
    return ((MC.EFC0.FSR & ((1 << (page / FLASH_SECTOR_PAGE)) << 16)) != 0);
  else
    return ((MC.EFC1.FSR & ((1 << ((page % FLASH_PAGE_NB) / FLASH_SECTOR_PAGE)) << 16)) != 0);
#else
  return ((MC.EFC0.FSR & ((1 << (page / FLASH_SECTOR_PAGE)) << 16)) != 0);
#endif
}

// UNLOCK
__attribute__((section(".ramfunc"))) void FlashUnlock (uint32_t adr) {
  unsigned  _cpsr;
  uint32_t  page;

  page = ((adr - (uint32_t)FLASH_BASE_ADDRESS) / FLASH_PAGE_SIZE_BYTE);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page >= FLASH_PAGE_NB * 2) return;
#else
  if (page >= FLASH_PAGE_NB) return;
#endif

  if (PageLocked (page)) {
    _cpsr = disableIRQ ();
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
    if (page < FLASH_PAGE_NB) {
      MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_UNLOCK | (_MC_PAGEN & (page << 8));
      FlashReady ();
    } else {
      MC.EFC1.FCR = _MC_CORRECT_KEY | _MC_FCMD_UNLOCK | (_MC_PAGEN & ((page % FLASH_PAGE_NB) << 8));
      FlashReady2 ();
    }
#else
    MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_UNLOCK | (_MC_PAGEN & (page << 8));
    FlashReady ();
#endif
    restoreIRQ (_cpsr);
  }
}

// LOCK
__attribute__((section(".ramfunc"))) void FlashLock (uint32_t adr) {
  unsigned  _cpsr;
  uint32_t  page;

  page = ((adr - (uint32_t)FLASH_BASE_ADDRESS) / FLASH_PAGE_SIZE_BYTE);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page >= FLASH_PAGE_NB * 2) return;
#else
  if (page >= FLASH_PAGE_NB) return;
#endif

  if (!PageLocked (page)) {
    _cpsr = disableIRQ ();

#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
    if (page < FLASH_PAGE_NB) {
      MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_LOCK | (_MC_PAGEN & (page << 8));
      FlashReady ();
    } else {
      MC.EFC1.FCR = _MC_CORRECT_KEY | _MC_FCMD_LOCK | (_MC_PAGEN & ((page % FLASH_PAGE_NB) << 8));
      FlashReady2 ();
    }
#else
    MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_LOCK | (_MC_PAGEN & (page << 8));
    FlashReady ();
#endif
    restoreIRQ (_cpsr);
  }
}

// y[W
__attribute__((section(".ramfunc"))) bool FlashPageWrite (uint32_t adr, int sz, uint32_t * buf) {
  unsigned  _cpsr;
  uint32_t  i, page, status;
  uint32_t  *Flash = (uint32_t *)adr;

  page = ((adr - (uint32_t)FLASH_BASE_ADDRESS) / FLASH_PAGE_SIZE_BYTE);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page >= FLASH_PAGE_NB * 2) return false;
#else
  if (page >= FLASH_PAGE_NB) return false;
#endif
  if (PageLocked (page)) return false;

  for(i = 0; (i < FLASH_PAGE_SIZE_BYTE) && (sz > 0); i++, sz -= 4)
    *Flash++ = *buf++;

  _cpsr = disableIRQ ();
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page < FLASH_PAGE_NB) {
    MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_START_PROG | (_MC_PAGEN & (page << 8));
    status = FlashReady ();
  } else {
    MC.EFC1.FCR = _MC_CORRECT_KEY | _MC_FCMD_START_PROG | (_MC_PAGEN & ((page % FLASH_PAGE_NB) << 8));
    status = FlashReady2 ();
  }
#else
  MC.EFC0.FCR = _MC_CORRECT_KEY | _MC_FCMD_START_PROG | (_MC_PAGEN & (page << 8));
  status = FlashReady ();
#endif
  restoreIRQ (_cpsr);

  if ((status & (_MC_PROGE | _MC_LOCKE)) != 0) return false;
  return true;
}

// y[W܂
bool FlashBlockWrite (uint32_t addr, int size, uint32_t *buff) {
  int       next;
  bool      status;
  uint32_t  dest;
  uint32_t  *src;

  dest = addr;
  src = buff;
  status = true;
  while (status & (size > 0)) {
    if (size <= FLASH_PAGE_SIZE_BYTE) next = size;
    else                              next = FLASH_PAGE_SIZE_BYTE;
    status = FlashPageWrite (dest, next, src);
    size -= next;
    src += FLASH_PAGE_SIZE_BYTE / 4;
    dest +=  FLASH_PAGE_SIZE_BYTE;
  }
  return status;
}

// UNLOCK̊mF
bool lockcheck (uint32_t addr) {
  uint32_t  page;

  page = ((addr - (uint32_t)FLASH_BASE_ADDRESS) / FLASH_PAGE_SIZE_BYTE);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
  if (page >= FLASH_PAGE_NB * 2) return false;
#else
  if (page >= FLASH_PAGE_NB) return false;
#endif
  return PageLocked (page);
}

// AhX͈͂̊mF
bool rangecheck (uint32_t addr) {
  return ((addr >=  FLASH_BASE_ADDRESS) && (addr < FLASH_FINAL_ADDR));
}

//========================================================
// main
//========================================================
// FLASH̍Ō8y[WɎg
#define FLASH_EEPROM_SIZE   (FLASH_PAGE_SIZE_BYTE * 8)
#define FLASH_EEPROM_ADDR   (FLASH_FINAL_ADDR - FLASH_EEPROM_SIZE)

int main (void) {
  char c;
  bool b;
  uint32_t i, j, x, y, *p;

  uint8_t erasedata[FLASH_PAGE_SIZE_BYTE];
  uint8_t writedata[FLASH_EEPROM_SIZE];

  // y[Wpf[^쐬
  memset (erasedata, 0xff, FLASH_PAGE_SIZE_BYTE);

  // y[WݗpeXgf[^쐬
  j = 0;
  for (p = (void *)writedata; p < (uint32_t *)&writedata[FLASH_EEPROM_SIZE]; ) {
    *p++ = 0x11223344;
    *p++ = 0xAABB0000 | j++;
  }

  enableIRQ ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));
  init_syscall (NULL, NULL);

  FlashInit ();

  while (1) {
    _us_puts ("\n>");
    _us_putc (c = _us_getc());
    switch (c) {
      case 'i': // flash info
        _us_puts ("\n--INFO");
        _us_printf ("\nMC.EFC0.FSR = 0x%08x", MC.EFC0.FSR);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
        _us_printf ("\nMC.EFC1.FSR = 0x%08x", MC.EFC1.FSR);
#endif
        break;
      case 'l': // unlock
        _us_puts ("\n--LOCK");
        i = FLASH_BASE_ADDRESS;
        j = FLASH_FINAL_ADDR - 1;
        _us_printf ("\nSTART ADDRESS(0x%08X)=0x", i);
        _us_scanf ("%x", &i);
        _us_printf ("\nEND ADDRESS(0x%08X)=0x", j);
        _us_scanf ("%x", &j);
        _us_printf ("\nLock range: 0x%08X..0x%08X", i, j);
        if (!rangecheck(i) || !rangecheck(j)) {
          _us_puts ("\nOut of range!");
          break;
        }
        for (; i < j; i++) FlashLock (i);
        _us_printf ("\nMC.EFC0.FSR = 0x%08x", MC.EFC0.FSR);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
        _us_printf ("\nMC.EFC1.FSR = 0x%08x", MC.EFC1.FSR);
#endif
        break;
      case 'u': // lock
        _us_puts ("\n--UNLOCK");
        i = FLASH_BASE_ADDRESS;
        j = FLASH_FINAL_ADDR - 1;
        _us_printf ("\nSTART ADDRESS(0x%08X)=0x", i);
        _us_scanf ("%x", &i);
        _us_printf ("\nEND ADDRESS(0x%08X)=0x", j);
        _us_scanf ("%x", &j);
        _us_printf ("\nUnlock range: 0x%08X..0x%08X", i, j);
        if (!rangecheck(i) || !rangecheck(j)) {
          _us_puts ("\nOut of range!");
          break;
        }
        for (; i < j; i++) FlashUnlock (i);
        _us_printf ("\nMC.EFC0.FSR = 0x%08x", MC.EFC0.FSR);
#if defined (__AT91SAM7S512__) | defined (__AT91SAM7X512__)
        _us_printf ("\nMC.EFC1.FSR = 0x%08x", MC.EFC1.FSR);
#endif
        break;
      case 'd': // dump mem
      case 'D':
        _us_puts ("\n--DUMP");
        if (c == 'd') i = FLASH_BASE_ADDRESS;
        else          i = FLASH_EEPROM_ADDR;
        _us_printf ("\nSTART ADDRESS(0x%08X)=0x", i);
        _us_scanf ("%x", &i);
        if (!rangecheck(i)) {
          _us_puts ("Out of range!");
          break;
        }
        c = 0;
        while ((c != '\33') && rangecheck(i)) {
          for (y = 0; y < 16 && rangecheck(i); y++) {
            _us_printf ("\r $%08X :", i);
            b = lockcheck (i);
            j = (i - FLASH_BASE_ADDRESS) / FLASH_PAGE_SIZE_BYTE;
            for (x = 0; x < 16 && rangecheck(i); x++) {
              _us_printf(" %02X", *(uint8_t *)i);
              i++;
            }
            _us_printf (" [%4d %c]\n", j % FLASH_PAGE_NB, b ? 'L' : 'U');
          }
          if (rangecheck(i)) {
            _us_puts ("[ESC] to exit");
            c = _us_getc ();
            _us_rx_purge ();
          }
        }
        break;

      case 'p': // page write
        _us_puts ("\n--PAGE WRITE");
        if (FlashPageWrite (FLASH_EEPROM_ADDR, sizeof(writedata), (void *)writedata))
          _us_puts ("\nSUCCESS");
        else
          _us_puts ("\nFAILURE");
        break;
      case 'b': // block write
        _us_puts ("\n--BLOCK WRITE");
        if (FlashBlockWrite (FLASH_EEPROM_ADDR, sizeof(writedata), (void *)writedata))
          _us_puts ("\nSUCCESS");
        else
          _us_puts ("\nFAILURE");
        break;
      case 'e': // block erase
        _us_puts ("\n--ERASE");
        for (i = FLASH_EEPROM_ADDR; i < FLASH_EEPROM_ADDR + FLASH_EEPROM_SIZE; i += FLASH_PAGE_SIZE) {
          b = FlashPageWrite (i, FLASH_PAGE_SIZE_BYTE, (void *)erasedata);
          if (!b) {
            _us_puts ("\nFAILURE");
            break;
          }
        }
        if (b) _us_puts ("\nSUCCESS");
        break;

      default:
        _us_puts ("\n?");
        break;
    }
    _us_rx_purge ();
  }
}
