//-----------------------------------------------------------
// smpl8(twi_LM73).c
// TWI(IIC)ڑ̉xZT(LM73)Ƃ̒ʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// LM73̏ڍׂ͈ȉ
//  http://www.national.com/pf/LM/LM73.html#Overview
// Gb^̓sEFCg}ĂA̎Ԃ̐
// PITgpĂ邱ƂɒӁB
//-----------------------------------------------------------

#include <math.h>

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PA10 -> TWD
  {1 << 10, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA11 -> TWCK
  {1 << 11, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
};
#else
static const TPin pins[] = {
  // PA3 -> TWD
  {1 <<  3, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA4 -> TWCK
  {1 <<  4, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
};
#endif

//========================================================
// MISC...
//========================================================
// ʃ[vɂȈՃEFCg֐
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// TWI
//========================================================
#define _TWI_BUS_CLOCK   400000 // in Hz

/* value of the PIT value to have 333ns @ 48 MHz
3 -1 since real time out = PIV + 1 */
#define _PIT_PIV_MICRO_SECOND_VALUE   0x2

//--------------------------------------------------------
// Wait function with the Periodic Interval Timer (PIT)
// (1us to 999us)
//--------------------------------------------------------
void TWI_WaitUS (uint32_t us) {
  uint32_t PitStatus = 0;   // Status register of the PIT
  uint32_t PitLoop = 0;     // Store the number of PIT Loop

  PIT.MR = _PIT_PITEN | _PIT_PIV_MICRO_SECOND_VALUE;

  for (PitLoop = 0; PitLoop <(us); ) {  // One PIT loop equals 333ns
    // Wait for the PIT counter overflow occurs
    while ((PIT.SR & _PIT_PITS) == 0) ;
    // Read the PIT Interval Value Reg. to clear it for the next overflow
    PitStatus = PIT.PIVR;
    // dummy access to avoid IAR warning
    PitStatus = PitStatus;
    PitLoop++;
  }
}

//--------------------------------------------------------
// Write a single data into a slave device without
// internal address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_WriteSingle (
  int SlaveAddr,
  char *data
) {
  uint32_t end = 0, status, error = 0;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR = SlaveAddr & ~_TWI_MREAD;
  // Write the data to send into THR. Start conditionn DADDR and R/W bit are sent automatically
  TWI.THR = *data;
  // NACK errata handling
  // Do not poll the TWI_SR
  // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
  // From 400Khz down to 1Khz, the time to wait will be in s range.
  // In this example the TWI period is 1/400KHz
  TWI_WaitUS (40);
  while (!end) {
    status = TWI.SR;
    if ((status & _TWI_NACK) == _TWI_NACK) {
      error++;
      end = 1;
    }
    // Wait for the Transmit ready is set
    if ((status & _TWI_TXRDY) == _TWI_TXRDY) end = 1;
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return error;
}

//--------------------------------------------------------
// Write a single data into a slave device with an
// internal address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_WriteSingleIadr (
  int SlaveAddr,
  int IntAddr,
  int IntAddrSize,
  char *data
) {
  uint32_t end = 0, status, error = 0;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR = SlaveAddr | (IntAddrSize & ~_TWI_MREAD);
  // Set TWI Internal Address Register if needed
  TWI.IADR = IntAddr;
  // Write the data to send into THR. Start conditionn DADDR and R/W bit are sent automatically
  TWI.THR = *data;
  // NACK errata handling
  // Do not poll the TWI_SR
  // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
  // From 400Khz down to 1Khz, the time to wait will be in s range.
  // In this example the TWI period is 1/400KHz
  TWI_WaitUS (40);
  while (!end) {
    status = TWI.SR;
    if ((status & _TWI_NACK) == _TWI_NACK) {
      error++;
      end = 1;
    }
    // Wait for the Transmit ready is set
    if ((status & _TWI_TXRDY) == _TWI_TXRDY) end = 1;
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return error;
}

//--------------------------------------------------------
// Write multiple data into a slave device without
// internal address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_WriteMultiple (
  int SlaveAddr,
  char *data,
  uint32_t NumOfBytes
) {
  uint32_t end = 0, status, error = 0, Count;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Wait until TXRDY is high to transmit
  status = TWI.SR;
  while (!(status & _TWI_TXRDY)) status = TWI.SR;
  // Set the TWI Master Mode Register
  TWI.MMR =  SlaveAddr & ~_TWI_MREAD;
  // Send the data
  for (Count = 0; Count < NumOfBytes; Count++) {
    // Write the data to send into THR. Start conditionn DADDR and R/W bit are sent automatically
    TWI.THR = *data++;
    // NACK errata handling
    // Do not poll the TWI_SR
    // Wait 3 x 9 TWCK pulse (max) before reading TWI_SR
    // From 400Khz down to 1Khz, the time to wait will be in s range.
    // In this example the TWI period is 1/400KHz
    TWI_WaitUS (40);
    while (!end) {
      status = TWI.SR;
      if ((status & _TWI_NACK) == _TWI_NACK) {
        error++;
        end = 1;
      }
      // Wait for the Transmit ready is set
      if ((status & _TWI_TXRDY) == _TWI_TXRDY) end = 1;
    }
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return error;
}

//--------------------------------------------------------
// Write multiple data into a slave device with internal
// address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_WriteMultipleIadr (
  int SlaveAddr,
  int IntAddr,
  int IntAddrSize,
  char *data,
  uint32_t NumOfBytes
) {
  uint32_t end = 0, status, error = 0, Count;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR = SlaveAddr | (IntAddrSize & ~_TWI_MREAD);
  // Set TWI Internal Address Register if needed
  TWI.IADR = IntAddr;
  // Wait until TXRDY is high to transmit
  status = TWI.SR;
  while (!(status & _TWI_TXRDY)) status = TWI.SR;
  // Send the data
  for (Count = 0; Count < NumOfBytes; Count++) {
    // Write the data to send into THR. Start conditionn DADDR and R/W bit are sent automatically
    TWI.THR = *data++;

    // NACK errata handling
    // Do not poll the TWI_SR
    // Wait 3 x 9 TWCK pulse (max) before reading TWI_SR
    // From 400Khz down to 1Khz, the time to wait will be in s range.
    // In this example the TWI period is 1/400KHz
    TWI_WaitUS (40);
    while (!end) {
      status = TWI.SR;
      if ((status & _TWI_NACK) == _TWI_NACK) {
        error++;
        end = 1;
      }
      // Wait for the Transmit ready is set
      if ((status & _TWI_TXRDY) == _TWI_TXRDY) end = 1;
    }
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return error;
}

//--------------------------------------------------------
// Read single data from a slave device without internal
// address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_ReadSingle (
  int SlaveAddr,
  char *data
) {
  uint32_t status, error = 0, end = 0;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR =  SlaveAddr | _TWI_MREAD;
  TWI.CR = _TWI_START | _TWI_STOP;
  // NACK errata handling
  // Do not poll the TWI_SR
  // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
  // From 400Khz down to 1Khz, the time to wait will be in s range.
  // In this example the TWI period is 1/400KHz
  TWI_WaitUS (40);
  while (!end) {
    status = TWI.SR;
    if ((status & _TWI_NACK) == _TWI_NACK) {
      error++;
      end = 1;
    }
    // Wait for the receive ready is set
    if ((status & _TWI_RXRDY) == _TWI_RXRDY) end = 1;
  }
  *(data) = TWI.RHR;
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return 0;
}

//--------------------------------------------------------
// Read single data from a slave device with internal
// address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_ReadSingleIadr (
  int SlaveAddr,
  int IntAddr,
  int IntAddrSize,
  char *data
) {
  uint32_t status, error = 0, end = 0;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR =  SlaveAddr | IntAddrSize | _TWI_MREAD;
  // Set TWI Internal Address Register if needed
  TWI.IADR = IntAddr;
  TWI.CR = _TWI_START | _TWI_STOP;
  // NACK errata handling
  // Do not poll the TWI_SR
  // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
  // From 400Khz down to 1Khz, the time to wait will be in s range.
  // In this example the TWI period is 1/400KHz
  TWI_WaitUS (40);
  while (!end) {
    status = TWI.SR;
    if ((status & _TWI_NACK) == _TWI_NACK) {
      error++;
      end = 1;
    }
    // Wait for the receive ready is set
    if ((status & _TWI_RXRDY) == _TWI_RXRDY) end = 1;
  }
  *(data) = TWI.RHR;
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return 0;
}

//--------------------------------------------------------
// Read multiple data from a slave device without internal
// address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_ReadMultiple (
  int SlaveAddr,
  uint32_t NumOfBytes,
  char *data
) {
  uint32_t status, error = 0, ReadCount, end = 0;

  // Enable Master Mode of the TWI
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR =  SlaveAddr | _TWI_MREAD ;
  // Send the Start + slave address
  TWI.CR = _TWI_START;
  // Read and store it into the buffer
  for (ReadCount= 0; ReadCount < NumOfBytes; ReadCount++) {
    // if next-lo-last data send the stop
    if (ReadCount == (NumOfBytes -1)) TWI.CR = _TWI_STOP;
    // NACK errata handling
    // Do not poll the TWI_SR
    // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
    // From 400Khz down to 1Khz, the time to wait will be in s range.
    // In this example the TWI period is 1/400KHz
    TWI_WaitUS (40);
    while (!end) {
      status = TWI.SR;
      if ((status & _TWI_NACK) == _TWI_NACK) {
        error++;
        end = 1;
      }
      // Wait until RXRDY is high to read the next data
      if ((status & _TWI_RXRDY) == _TWI_RXRDY) end = 1;
    }
    // Read the char received
    *data++ = TWI.RHR;
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return 0;
}

//--------------------------------------------------------
// Read multiple data from a slave device with internal
// address. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_ReadMultipleIadr (
  int SlaveAddr,
  uint32_t NumOfBytes,
  int IntAddr,
  int IntAddrSize,
  char *data
) {
  uint32_t status, error = 0, ReadCount, end = 0;

  // Enable Master Mode of the TWI
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR =  SlaveAddr | IntAddrSize | _TWI_MREAD;
  // Set TWI Internal Address Register if needed
  TWI.IADR = IntAddr;
  // Send the Start + slave address
  TWI.CR = _TWI_START;
  // Read and store it into the buffer
  for (ReadCount = 0; ReadCount < NumOfBytes; ReadCount++) {
    // if next-lo-last data send the stop
    if (ReadCount == (NumOfBytes - 1)) TWI.CR = _TWI_STOP;
    // NACK errata handling
    // Do not poll the TWI_SR
    // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
    // From 400Khz down to 1Khz, the time to wait will be in s range.
    // In this example the TWI period is 1/400KHz
    TWI_WaitUS (40);
    while (!end) {
      status = TWI.SR;
      if ((status & _TWI_NACK) == _TWI_NACK) {
        error++;
        end = 1;
      }
      // Wait until RXRDY is high to read the next data
      if ((status & _TWI_RXRDY) == _TWI_RXRDY) end = 1;
    }
    // Read the char received
    *data = TWI.RHR;
    data++;
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return 0;
}

//--------------------------------------------------------
// Write a single data into a slave device to see if it is
// connected. Takes into account the NACK errata.
//--------------------------------------------------------
int TWI_ProbeDevices (int SlaveAddr) {
  uint32_t end = 0, status, result;

  // Enable Master Mode
  TWI.CR = _TWI_MSEN ;
  // Set the TWI Master Mode Register
  TWI.MMR = SlaveAddr & ~_TWI_MREAD;
  // Write the data to send into THR. Start conditionn DADDR and R/W bit are sent automatically
  TWI.THR = 0x55;
  // NACK errata handling
  // Do not poll the TWI_SR
  // Wait 3 x 9 TWCK pulse (max) 2 if IADRR not used, before reading TWI_SR
  // From 400kHz down to 1kHz, the time to wait will be in s range.
  // In this example the TWI period is 1/400kHz
  TWI_WaitUS (50);
  while (!end) {
    status = TWI.SR;
    if ((status & _TWI_NACK) == _TWI_NACK) {
      result = _TWI_NACK ;
      end=1;
    }
    // Wait for the Transmit ready is set
    else if ((status & _TWI_TXRDY) == _TWI_TXRDY) {
      end=1;
      result = SlaveAddr>>16;
    }
  }
  // Wait for the Transmit complete is set
  status = TWI.SR;
  while (!(status & _TWI_TXCOMP)) status = TWI.SR;

  return result;
}

//--------------------------------------------------------
// Initializes TWI device
//--------------------------------------------------------
void TWI_Init (int TwiClock) {

  void SetTwiClock (int tclk) {
    uint32_t cldiv,ckdiv=1 ;
    /* CLDIV = ((Tlow x 2^CKDIV) -3) x Tmck */
    /* CHDIV = ((THigh x 2^CKDIV) -3) x Tmck */
    /* Only CLDIV is computed since CLDIV = CHDIV (50% duty cycle) */
    while ((cldiv = ((F_CPU / (2 * tclk)) - 3) / pow (2, ckdiv)) > 255) ckdiv++ ;
    TWI.CWGR = (ckdiv << 16) | ((uint32_t)cldiv << 8) | (uint32_t)cldiv;
  }

  // Configure PMC by enabling TWI clock
  PMC.PCER = 1 << TWI_PID;

  // Configure TWI in master mode
  // Disable interrupts
  TWI.IDR = (uint32_t) -1;
  // Reset peripheral
  TWI.CR = _TWI_SWRST;
  TWI.RHR;
  TWI.CR = _TWI_MSDIS;
  // Set Master mode
  TWI.CR = _TWI_MSEN;

  // Set TWI Clock Waveform Generator Register
  SetTwiClock (TwiClock);
}

//========================================================
// LM73
//========================================================
/* addr: "1001 101"= $4d */
#define _LM73_I2C_ADDRESS (0x4d << 16)

char TWI_LM73_ReadRegister (char addr) {
  char Value;
  TWI_ReadSingleIadr (
    _LM73_I2C_ADDRESS,
    addr,
    _TWI_IADRSZ_1_BYTE,
    &Value
  );
  return Value;
}

int TWI_LM73_WriteRegister (char addr, char Value) {
  TWI_WriteSingleIadr (
    _LM73_I2C_ADDRESS,
    addr,
    _TWI_IADRSZ_1_BYTE,
    &Value
  );
  return (1);
}

uint16_t TWI_LM73_ReadTempRegister (void) {
  char Value[2];
  TWI_ReadMultipleIadr (
    _LM73_I2C_ADDRESS,
    2,
    0x0,
    _TWI_IADRSZ_1_BYTE,
    Value
  );
  return (Value[0] << 6) | (Value[1] >> 2);
}

//========================================================
// main
//========================================================
void main (void) {
  int tmp;

  enableIRQ ();
  PIO_Configure (pins, PIO_LISTSIZE (pins));
  TWI_Init (_TWI_BUS_CLOCK);

  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // Init LM73
  TWI_LM73_WriteRegister (1, 0x68); // power up
  TWI_LM73_WriteRegister (4, 0xe0); // change to 13bit resolution

  for (;;)  {
    tmp =  TWI_LM73_ReadTempRegister () * 3125;
    _us_printf ("TEMP=%3d.%05d \r", tmp / 100000, tmp % 100000);

    if (_us_rx_buff ()) {
      if (_us_getc () == 0x1b) {
#if defined (__UDP__)
        udp_disconnect ();
        wait(5000);
#endif
        RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
      }
    }

    wait(100);
  }
}
